package WebFlow.ToolBar;

//import VTKModel;
import vtk.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.FileInputStream;
import java.net.URL;

import WebFlow.*;
//import org.omg.CORBA.*;
import WebFlow.RemoteFile.*;
import WebFlow.RemoteFile.RemoteFilePackage.*;

public class App2 extends Applet {
    VTKModel md;
    String mdname = null;
    String message = null;
  String filepath = null;

    vtkPolyDataReader pr = null;
    vtkWarpVector warp = null;
    vtkGeometryFilter ds2poly = null;
    vtkCleanPolyData clean = null;
    vtkPolyDataNormals normals = null;
    vtkVectorDot color = null;
    vtkDataSetMapper plateMapper = null;
    vtkPanel panel = null;
    vtkActor a = null;

    String urlfile="http://birch.csit.fsu.edu:8001/GOW/IOR/master.txt";
    String masterIOR;
    public org.omg.CORBA.ORB orb;
    public WebFlowContext master=null;
    org.omg.CORBA.Object obj;
    RemoteFile rf;

  public App2 (String filepath) {
    this.filepath = filepath;
  }

    public static void main(String args[]) {
  
      /*
      Frame tempframe = new Frame("VTK Java Demo");     
	  App2 applet = new  App2();
      tempframe.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                        System.exit(0);
                }
      });
      tempframe.add(applet,BorderLayout.CENTER);
      tempframe.setSize(420,500);
      applet.init();
      applet.start();
      tempframe.setVisible(true);
      */
      //new AppletFrame(new App2(),420,500);
    }

    public void testme ()
      {
      //System.out.println("Starting Render");
      }

  public void init()
  {
    //Connect to the master
    masterIOR=WebFlow.ClientUtils.getIORFromURL(urlfile);
    orb=WebFlow.ClientUtils.initializeORB(masterIOR,orb);
    master=WebFlow.ClientUtils.getMasterServer(masterIOR,orb);

    //Instatiate some webflow objects
    obj=WebFlow.ClientUtils.makeModule(master,"RemoteFile");
    rf=RemoteFileHelper.narrow(obj);
    rf.test();

      GridBagLayout grid = new GridBagLayout();
      
      this.setLayout(grid);

      panel = new vtkPanel();
      panel.resize(400,400);
      constrain(this,panel,0,0,8,8);

      FileInputStream is = null;
      try 
	{
	
	CheckboxGroup cbg = new CheckboxGroup();
	constrain(this,new Checkbox("Mode 1",cbg,true),0,8,2,1);
	constrain(this,new Checkbox("Mode 2",cbg,false),2,8,2,1);
	constrain(this,new Checkbox("Mode 4",cbg,false),4,8,2,1);
	constrain(this,new Checkbox("Mode 8",cbg,false),6,8,2,1);
	constrain(this,new Checkbox("Scalar Coloring"),0,9,3,1);
	CheckboxGroup cbg2 = new CheckboxGroup();
	constrain(this,new Checkbox("Surface",cbg2,true),4,9,2,1);
	constrain(this,new Checkbox("Wireframe",cbg2,false),6,9,2,1);

	//mdname = "c:\\VtkGOW\\GOW\\WEB-INF\\src\\BeanContext_2.2.3\\ToolBar\\plate.vtk";
	//is = new FileInputStream(mdname);
	//md = new VTKModel(is);

        //mdname = "/home/scri97/users/cyoun/birch/GATEWAY/apache1.3.12/WWW/GOW/plate.vtk";
        mdname = filepath;
        byte buffer[] = null;
        String vtkdata = null;
        try {
          rf.open(mdname,"r");
          buffer = rf.getBlock();
          vtkdata = new String(buffer);
          while(true) {
            if(buffer.length > 0) {
              buffer = rf.getBlock();
              vtkdata += new String(buffer);
            }
            else throw new EOFFileException();
          }
        } catch(EOFFileException ex) {
          rf.close();
        }

	// create the model
	pr = new vtkPolyDataReader();
	pr.ReadFromInputStringOn();
	//pr.SetInputString(md.GetData());
	pr.SetInputString(vtkdata);
	
        //pr.SetFileName("plate.vtk");


	pr.SetVectorsName("mode1");
	warp = new vtkWarpVector();
	warp.SetInput(pr.GetOutput());
	warp.SetScaleFactor(0.5);
	ds2poly = new vtkGeometryFilter();
	ds2poly.SetInput(warp.GetOutput());
	clean = new vtkCleanPolyData();
	clean.SetInput(ds2poly.GetOutput());
	normals = new vtkPolyDataNormals();
	normals.SetInput(clean.GetOutput());
	color = new vtkVectorDot();
	color.SetInput(normals.GetOutput());
	plateMapper = new vtkDataSetMapper();
	plateMapper.ScalarVisibilityOff();
	plateMapper.SetInput(color.GetOutput());
	plateMapper.SetScalarRange(-1,1);
	a = new vtkActor();
	a.SetMapper(plateMapper);

	panel.getRenderer().AddActor(a);
	panel.getRenderer().SetStartRenderMethod(this,"testme");
	}
      catch(Exception e) 
	{
	e.printStackTrace();
	md = null;
	message = e.toString();
	}
      try 
	{
	if (is != null) is.close();
	} 
      catch(Exception e) 
	{
	}

      layout();
      this.setBackground(new Color(120, 140, 160));
      show();
      }

    public void constrain(Container cont, Component comp,
                          int grid_x, int grid_y, 
                          int grid_width, int grid_height)
      {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x;
      c.gridy = grid_y;
      c.gridwidth = grid_width;
      c.gridheight = grid_height;
      c.anchor = GridBagConstraints.NORTH;

      ((GridBagLayout)cont.getLayout()).setConstraints(comp,c);
      cont.add(comp);
      }

    public boolean keyDown(Event e, int key) 
      {
      if (!super.keyDown(e,key))
        {
        return panel.keyDown(e,key);
        }
      return true;
      }

    public boolean action(Event evt, Object arg) 
      {
      if (arg instanceof Boolean) 
	  {
	  if (((Checkbox)evt.target).getLabel().equals("Mode 1")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode1");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Mode 2")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode2");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Mode 4")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode4");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Mode 8")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode8");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Scalar Coloring")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      plateMapper.ScalarVisibilityOn();
	      panel.Render();
	      }
	    else
	      {
	      plateMapper.ScalarVisibilityOff();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Surface")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      a.GetProperty().SetRepresentationToSurface();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Wireframe")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      a.GetProperty().SetRepresentationToWireframe();
	      panel.Render();
	      }
	    return true;
	    }
	  } 
	return super.action(evt, arg);
        }
}
