/**
 * Program: MyToolBar.java
 * Comments: A frame to diplay the tool bar menu.
 */

package WebFlow.ToolBar;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import WebFlow.*;
import org.omg.CORBA.*;
import WebFlow.submitJob.*;
import WebFlow.SerialHash.*;
import WebFlow.Control.*;
import WebFlow.RemoteFile.*;
import WebFlow.hashtable.*;
import WebFlow.ContextManager.*;
import WebFlow.RemoteParse.*;
import java.io.File;

public class MyToolBar extends JFrame 
    implements ActionListener{

    JMenuBar menuBar;
    JMenu FileMenu,EditMenu,BrowserMenu,JobMenu,MonitorMenu,FBMenu,LocMenu;
    CmdMenuItem ExitItem,AddApp,RmApp,WBOpen,WBClose,
	JMOpen,JMClose,FBOpen,FBClose;
    AppletFrame fbApplet, jmApplet;
    Vector sjMenuVec,sjCmdVec;
    GOWControl gowcontrol;

    String cmd;
    String descDir;
  String urlstring;

    //slave WebFlow server
    String slavedescDir;
    String slaveID;
    String masterID;
    JMenu slaveJobMenu;
    Vector slavesjMenuVec,slavesjCmdVec;
    String[] slaveprobNames=null;
    String[] slaveprobVals=null;
  String slaveServerOK=null;
    

    String[] probNames=null;
    String[] probVals=null;
    String userName;

  //vtk stuffs
  String[] vtkprobNames=null;
  Vector vtkMenuVec,vtkCmdVec;

  //test case
  String[] jobNames=null;
    
    //The following is temporary code until I can revise.
    ORB orb;
    WebFlowContext master=null,myContext;
    org.omg.CORBA.Object myContextObj,mySubmitObj,mySerHashObj;
    org.omg.CORBA.Object myCMObj,myCDObj,mySCObj,myRFObj,myRPObj;
    submitJob sj;
    SerialHash sh;
    ContextManager cm;
    RemoteFile rf;
    ContextData cd;
    SaveContext sc;
  RemoteParse rp;

    //slave WebFlow Server
    WebFlowContext slaveWFC=null;
    submitJob slavesj;
    SerialHash slavesh;
    ContextManager slavecm;
    RemoteFile slaverf;
    ContextData slavecd;
    SaveContext slavesc;
  RemoteParse slaverp;

    public MyToolBar(){
    }

    public MyToolBar(GOWControl gc) {
	setTitle("GOW Tool Bar");
	gowcontrol=gc;

  	menuBar=new JMenuBar();
  	setJMenuBar(menuBar);
	sjMenuVec=new Vector();
	sjCmdVec=new Vector();

        //vtk stuffs
	vtkMenuVec=new Vector();
	vtkCmdVec=new Vector();

	//Use GOWControl to set some things.
	descDir=gowcontrol.getDescDir();
	userName=gowcontrol.getUserName();
	cmd=gowcontrol.getBrowserCommand();
	master=gowcontrol.getMaster();
        urlstring=gowcontrol.getUrlString();
        urlstring += "/GOW";

	//slave WebFlow server
	slavedescDir = gowcontrol.getDescDirForSlave();
	slaveID = gowcontrol.getSlaveID();
	masterID = master.getObjectID();
        slaveWFC = WebFlowContextHelper.narrow(master.getContext(masterID+"/"+slaveID));
	slavesjMenuVec=new Vector();
	slavesjCmdVec=new Vector();
        slaveServerOK=gowcontrol.getSlaveServerOK();

	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
	    });

	try {
	    myContextObj=master.addNewContext(userName);
	    myContext=WebFlowContextHelper.narrow(myContextObj);

	    mySubmitObj=myContext.addNewModule("submit");
	    mySerHashObj=myContext.addNewModule("SerialHash");
	    myCMObj=myContext.addNewModule("ContextManager");
	    myRFObj=myContext.addNewModule("RemoteFile");
	    myCDObj=myContext.addNewModule("ContextData");
	    mySCObj=myContext.addNewModule("SaveContext");
	    myRPObj=myContext.addNewModule("RemoteParse");
	    sj=submitJobHelper.narrow(mySubmitObj);
	    sh=SerialHashHelper.narrow(mySerHashObj);
	    cm=ContextManagerHelper.narrow(myCMObj);
	    rf=RemoteFileHelper.narrow(myRFObj);
	    cd=ContextDataHelper.narrow(myCDObj);
	    sc=SaveContextHelper.narrow(mySCObj);
            rp=RemoteParseHelper.narrow(myRPObj);

	    //The following sets up the context manager and restores
	    //the context.
	    cm.init(myContext,mySCObj,myRFObj);
	    if(!cm.setUserContextData(myContext,descDir,userName)){
              //sc.readContextData(myContext,descDir+File.separator+userName);
                sc.readContextData(myContext,descDir+"/"+userName);
		WebFlow.ClientUtils.restoreChildren(myContext,cm,sc);
	    }

	    //slave WebFlow Server
            if(slaveServerOK.equals("Yes")) {
              myContextObj=slaveWFC.addNewContext(userName);
              myContext=WebFlowContextHelper.narrow(myContextObj);

              mySubmitObj=myContext.addNewModule("submit");
              mySerHashObj=myContext.addNewModule("SerialHash");
              myCMObj=myContext.addNewModule("ContextManager");
              myRFObj=myContext.addNewModule("RemoteFile");
              myCDObj=myContext.addNewModule("ContextData");
              mySCObj=myContext.addNewModule("SaveContext");
              myRPObj=myContext.addNewModule("RemoteParse");
              slavesj=submitJobHelper.narrow(mySubmitObj);
              slavesh=SerialHashHelper.narrow(mySerHashObj);
              slavecm=ContextManagerHelper.narrow(myCMObj);
              slaverf=RemoteFileHelper.narrow(myRFObj);
              slavecd=ContextDataHelper.narrow(myCDObj);
              slavesc=SaveContextHelper.narrow(mySCObj);
              slaverp=RemoteParseHelper.narrow(myRPObj);
	    
              //The following sets up the context manager and restores
              //the context.
              slavecm.init(myContext,mySCObj,myRFObj);
              if(!slavecm.setUserContextData(myContext,slavedescDir,userName)){
                //slavesc.readContextData(myContext,slavedescDir+File.separator+userName);
		slavesc.readContextData(myContext,slavedescDir+"/"+userName);
		WebFlow.ClientUtils.restoreChildren(myContext,slavecm,slavesc);
              }
            }
	}
	
	catch (Exception ex) {
	    ex.printStackTrace();
	}

        /*
        rp.init(descDir+userName+"/JobDescTest.xml","http://birch.csit.fsu.edu:8001/GOW");
        rp.addJob("Gateway.job");
        rp.addJobParams("Gateway.job","User","cyoun");
        rp.addJobParams("Gateway.job","Machine","dirac.csit.fsu.edu");
        rp.addJobParams("Gateway.job","Code","Ising");
        rp.addJobParams("Gateway.job","Status","Pending");
        rp.addJobParams("Gateway.job","Application","Yes");
        rp.addJobParams("Gateway.job","Directory","/tmp");
        rp.addParseJobNode("Gateway.job");
        rp.saveDocToFile();

        jobNames = rp.getJobNames();
        for(int i=0;i<jobNames.length;i++){
          System.out.println("jobNames: "+jobNames[i]);
        }
        */

	fbApplet=new AppletFrame(new UDapplet(),"File Browser");
	fbApplet.hide();
	fbApplet.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e){
		    fbApplet.hide();
		}
	    });




	//The job monitor needs a reference to the submitJob module.
	jmApplet=new AppletFrame(new TrackerApplet(this),"Job Monitor");
	jmApplet.hide();
	jmApplet.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e){
		    jmApplet.hide();
		}
	    });



	/* The remainder of the constructor sets up the GUI */
	FileMenu=new JMenu("File");
	ExitItem=new CmdMenuItem("Exit");
	ExitItem.addActionListener(this);
	ExitItem.setCommand(new ExitCmd());
	FileMenu.add(ExitItem);
	menuBar.add(FileMenu);

	EditMenu=new JMenu("Edit");
	AddApp=new CmdMenuItem("Add Local Application");
	AddApp.addActionListener(this);
	AddApp.setCommand(new AddCmd());
	AddApp.setEnabled(false);
	RmApp=new CmdMenuItem("Remove Local Application");
	RmApp.addActionListener(this);
	RmApp.setCommand(new RmCmd());
	RmApp.setEnabled(false);
	EditMenu.add(AddApp);
	EditMenu.add(RmApp);
	menuBar.add(EditMenu);

	BrowserMenu=new JMenu("Web Browser");
	WBOpen=new CmdMenuItem("Open");
	WBOpen.addActionListener(this);
	WBOpen.setCommand(new WBOpenCmd(cmd));
	BrowserMenu.add(WBOpen);
	menuBar.add(BrowserMenu);

	JobMenu=new JMenu("Submit Job(M)");
	JobMenu.add("Pending Jobs:");
	JobMenu.addSeparator();
	JobMenu.addMenuListener(new MenuListener() {
		
            //Must override the following 
            //when implementing the MenuListener.
            public void menuCanceled(MenuEvent me){
              System.out.println("Menu Canceled");
              JMenu menuSource=(JMenu)me.getSource();
              destroyDynMenu(menuSource);
            }
    
            //This is called whenever the mouse moves away from the selected
            //menu, or an item from the menu is selected and the pop-up is
            //dismissed.
            public void menuDeselected(MenuEvent me) {
              JMenu menuSource=(JMenu)me.getSource();
              destroyDynMenu(menuSource);
            }
		
            public void menuSelected(MenuEvent me) {
              JMenu menuSource=(JMenu)me.getSource();
              rp.init(descDir+userName+"/JobDesc.xml",urlstring);
              //sh.openHash(descDir+userName+"/probHash");	
              //probNames=sh.getHashNames();
              //probNames=rp.getJobNames();
              String[] tmp = rp.getJobNames();
              if(tmp.length != 0) {
                probNames = new String[tmp.length];
                for(int i=0; i<tmp.length;i++) {
                  if(!tmp[i].trim().endsWith(".vtk")) probNames[i] = tmp[i];
                }
              } else
                probNames=rp.getJobNames();

              //probVals=sh.getHashValues();
              constructDynMenu(menuSource);
              //sh.closeHash();
            }

            /**
             * Create the submit job menu dynamically from the static hash
             * table.
             */
            private void constructDynMenu(JMenu parent){
              for(int i=0;i<probNames.length;i++){
                sjMenuVec.add(new CmdMenuItem(probNames[i]));
                String dir=descDir+userName+"/JobDesc.xml";
                //sjCmdVec.add(new SJCmd(probNames[i],probVals[i],sj,sh,dir));
                sjCmdVec.add(new SJCmd(probNames[i],urlstring,sj,sh,rp,dir));
                ((CmdMenuItem)sjMenuVec.get(i)).
                addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent e){
                      CommandHolder ch=(CommandHolder)e.getSource();
                      ch.getCommand().Execute();
                    }
                  });
                ((CmdMenuItem)sjMenuVec.get(i)).
                setCommand((SJCmd)sjCmdVec.get(i));
                parent.add((CmdMenuItem)sjMenuVec.get(i));
              }
            }
            
            /**
             * The mouse has been moved away from the submit job menu, or else
             * one of the items has been selected.  Dispose of everything.
             * Note this approach relies on the garbage collector to clean up,
             * which I may regret one day.
             */
            private void destroyDynMenu(JMenu parent) {
              for(int i=0;i<sjMenuVec.size();i++) {
                parent.remove((CmdMenuItem)sjMenuVec.get(i));
              }
              sjMenuVec.clear();
              sjCmdVec.clear();
            }
            
          });
	menuBar.add(JobMenu);

	//slave WebFlow Server
        if(slaveServerOK.equals("Yes")) {
          slaveJobMenu=new JMenu("Submit Job(S)");
          slaveJobMenu.add("Pending Jobs:");
          slaveJobMenu.addSeparator();
          slaveJobMenu.addMenuListener(new MenuListener() {
		
              //Must override the following 
              //when implementing the MenuListener.
              public void menuCanceled(MenuEvent me){
                System.out.println("Menu Canceled(slave)");
                JMenu menuSource=(JMenu)me.getSource();
                destroyDynMenu(menuSource);
              }
    
              //This is called whenever the mouse moves away from the selected
              //menu, or an item from the menu is selected and the pop-up is
              //dismissed.
              public void menuDeselected(MenuEvent me) {
                JMenu menuSource=(JMenu)me.getSource();
                destroyDynMenu(menuSource);
              }
              
              public void menuSelected(MenuEvent me) {
                JMenu menuSource=(JMenu)me.getSource();
                
                slaverp.init(slavedescDir+userName+"/JobDesc.xml",urlstring);
                slaveprobNames=slaverp.getJobNames();
                
                //slavesh.openHash(slavedescDir+userName+"/probHash");
                //slaveprobNames=slavesh.getHashNames();
                //slaveprobVals=slavesh.getHashValues();
                constructDynMenu(menuSource);
                //slavesh.closeHash();
              }
              
              /**
               * Create the submit job menu dynamically from the static hash
               * table.
               */
              private void constructDynMenu(JMenu parent){
                for(int i=0;i<slaveprobNames.length;i++){
                  slavesjMenuVec.add(new CmdMenuItem(slaveprobNames[i]));
                  //String dir=slavedescDir+userName+"/probHash";
                  String dir=slavedescDir+userName+"/JobDesc.xml";
                  //slavesjCmdVec.add(new SJCmd(slaveprobNames[i],slaveprobVals[i],slavesj,slavesh,dir));
                  slavesjCmdVec.add(new SJCmd(slaveprobNames[i],urlstring,slavesj,slavesh,slaverp,dir));
                  ((CmdMenuItem)slavesjMenuVec.get(i)).
                  addActionListener( new ActionListener() {
                      public void actionPerformed(ActionEvent e){
                        CommandHolder ch=(CommandHolder)e.getSource();
                        ch.getCommand().Execute();
                      }
                    });
                  ((CmdMenuItem)slavesjMenuVec.get(i)).
                  setCommand((SJCmd)slavesjCmdVec.get(i));
                  parent.add((CmdMenuItem)slavesjMenuVec.get(i));
                }
              }

              /**
               * The mouse has been moved away from the submit job menu, or else
               * one of the items has been selected.  Dispose of everything.
               * Note this approach relies on the garbage collector to clean up,
               * which I may regret one day.
               */
              private void destroyDynMenu(JMenu parent) {
                for(int i=0;i<slavesjMenuVec.size();i++) {
                  parent.remove((CmdMenuItem)slavesjMenuVec.get(i));
                }
                slavesjMenuVec.clear();
                slavesjCmdVec.clear();
              }
              
	    });
          menuBar.add(slaveJobMenu);
        }

	MonitorMenu=new JMenu("Job Monitor");
	JMOpen=new CmdMenuItem("Open");
	JMOpen.addActionListener(this);
	JMOpen.setCommand(new AppOpenCmd(jmApplet));
	JMClose=new CmdMenuItem("Close");
	JMClose.addActionListener(this);
	JMClose.setCommand(new AppCloseCmd(jmApplet));
	MonitorMenu.add(JMOpen);
	MonitorMenu.add(JMClose);
	menuBar.add(MonitorMenu);
	
	FBMenu=new JMenu("File Browser");
	FBOpen=new CmdMenuItem("Open");
	FBOpen.addActionListener(this);
	FBOpen.setCommand(new AppOpenCmd(fbApplet));
	FBClose=new CmdMenuItem("Close");
	FBClose.addActionListener(this);
	FBClose.setCommand(new AppCloseCmd(fbApplet));
	FBMenu.add(FBOpen);
	FBMenu.add(FBClose);
	menuBar.add(FBMenu);

	LocMenu=new JMenu("Local Applications");
	LocMenu.add("VTK File List:");
	LocMenu.addSeparator();
	LocMenu.addMenuListener(new MenuListener() {
		
            //Must override the following 
            //when implementing the MenuListener.
            public void menuCanceled(MenuEvent me){
              System.out.println("Menu Canceled");
              JMenu menuSource=(JMenu)me.getSource();
              destroyDynMenu(menuSource);
            }
    
            //This is called whenever the mouse moves away from the selected
            //menu, or an item from the menu is selected and the pop-up is
            //dismissed.
            public void menuDeselected(MenuEvent me) {
              JMenu menuSource=(JMenu)me.getSource();
              destroyDynMenu(menuSource);
            }
		
            public void menuSelected(MenuEvent me) {
              JMenu menuSource=(JMenu)me.getSource();
              rp.init(descDir+userName+"/vtkDesc.xml",urlstring);
              //sh.openHash(descDir+userName+"/probHash");	
              //probNames=sh.getHashNames();
              String[] tmp = rp.getJobNames();
              if(tmp.length != 0) {
                vtkprobNames = new String[tmp.length];
                for(int i=0; i<tmp.length;i++) {
                  //System.out.println("vtk: "+tmp[i]);
                  if(tmp[i].trim().endsWith(".vtk")) vtkprobNames[i] = tmp[i];
                }
              } else
                vtkprobNames=rp.getJobNames();
              //probVals=sh.getHashValues();
              constructDynMenu(menuSource);
              //sh.closeHash();
            }

            /**
             * Create the submit job menu dynamically from the static hash
             * table.
             */
            private void constructDynMenu(JMenu parent){
              for(int i=0;i<vtkprobNames.length;i++){
                vtkMenuVec.add(new CmdMenuItem(vtkprobNames[i]));
                String dir=descDir+userName+"/vtkDesc.xml";
                //sjCmdVec.add(new SJCmd(probNames[i],probVals[i],sj,sh,dir));
                vtkCmdVec.add(new vtkCmd(vtkprobNames[i],urlstring,sj,sh,rp,dir));
                ((CmdMenuItem)vtkMenuVec.get(i)).
                addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent e){
                      CommandHolder ch=(CommandHolder)e.getSource();
                      ch.getCommand().Execute();
                    }
                  });
                ((CmdMenuItem)vtkMenuVec.get(i)).
                setCommand((vtkCmd)vtkCmdVec.get(i));
                parent.add((CmdMenuItem)vtkMenuVec.get(i));
              }
            }

            /**
             * The mouse has been moved away from the submit job menu, or else
             * one of the items has been selected.  Dispose of everything.
             * Note this approach relies on the garbage collector to clean up,
             * which I may regret one day.
             */
            private void destroyDynMenu(JMenu parent) {
              for(int i=0;i<vtkMenuVec.size();i++) {
                parent.remove((CmdMenuItem)vtkMenuVec.get(i));
              }
              vtkMenuVec.clear();
              vtkCmdVec.clear();
            }
          });
	menuBar.add(LocMenu);
    }
    
    //I implemented the "command" design pattern for the commands so that
    //they could be separated from the code that sets up the visual 
    //components.
    public void actionPerformed(ActionEvent e){
	CommandHolder ch=(CommandHolder)e.getSource();
	ch.getCommand().Execute();
    }

    /**
     * These are some accessor methods for sharing data with other
     * objects.
     */
    
    public submitJob getSubmitJob() { return sj; }
    public ContextManager getContextManager() { return cm; }

    //slave WebFlow Server
    public submitJob getSubmitJobForSlave() { return slavesj; }
    public ContextManager getContextManagerForSlave() { return slavecm; }
}
	
